package fr.asip.cps3.exemple.vues.ecrans.saisie;

import java.awt.GridBagLayout;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.border.EmptyBorder;

import fr.asip.cps3.exemple.vues.FenetrePrincipale;
import fr.asip.cps3.exemple.vues.composants.GridBagHelper;
import fr.asip.cps3.exemple.vues.ecrans.EcranUtil;

/**
 * Classe permettant de modéliser l'écran de saisie de 2 PIN
 */
public class Saisie2PIN extends Saisie1PIN {

	/**
	 * Libellé PIN 2
	 */
	protected JLabel libellePIN2;
	
	/**
	 * Texte PIN 2
	 */
	protected JPasswordField textePIN2;
	
	/**
	 * Constructeur à 2 arguments
	 * @param fenetre La fenêtre qui doit contenir l'écran de saisie
	 * @param typeEcran Type d'écran
	 */
	public Saisie2PIN(FenetrePrincipale fenetre, int typeEcran) {
		this(fenetre, typeEcran, "Entrez le code :", "Ré-entrez le code :");
	}

	/**
	 * Constructeur à 3 arguments
	 * @param fenetre La fenêtre qui doit contenir l'écran de saisie
	 * @param typeEcran Type d'écran
	 * @param libelle1 Libellé du champ PIN
	 * @param libelle2 Libellé du champ PIN2
	 */
	public Saisie2PIN(FenetrePrincipale fenetre, int typeEcran, String libelle1, String libelle2) {

		super(fenetre,typeEcran);
		libellePIN = new JLabel(libelle1);
		libellePIN2 = new JLabel(libelle2);
		textePIN2 = new JPasswordField(32);
    	
	}
	
	/**
     * Renvoie le deuxième code PIN
     * @return Le deuxième code PIN
     */
	public char[] getPIN2() {
		if(textePIN2 != null)
			return textePIN2.getPassword();
		return null;
	}	
	
	/**
	 * Affiche les champs d'entrée
	 */
    public void affiche() {

    	JFrame fenetre = this.fenetre.getFenetre();
    	
    	if(fenetre != null && fenetre.getContentPane() != null) {
    	
	    	EcranUtil.supprimeTousLesComposants(((JPanel)fenetre.getContentPane()));
	    	
	        // Création du layout
	    	((JPanel)fenetre.getContentPane()).setBorder(new EmptyBorder(0, 0, 0, 0));
	        GridBagLayout layout = new GridBagLayout();
	        ((JPanel)fenetre.getContentPane()).setLayout(layout);
	        
	        // Ajout des composants
	        GridBagHelper g = new GridBagHelper(fenetre.getContentPane());
	        // Ligne 0
	        g.ajoute(libellePIN, EcranUtil.styleLibelleSaisie, 0, 0, 1, 1);
	        g.ajoute(textePIN, EcranUtil.styleChampTexteSaisie, 0, 1, 1, 1);
	        // Ligne 1
	        g.ajoute(libellePIN2, EcranUtil.styleLibelleSaisie, 1, 0, 1, 1);
	        g.ajoute(textePIN2, EcranUtil.styleChampTexteSaisie, 1, 1, 1, 1);
	        // Ligne 2	        
	        g.ajoute(soumettre, EcranUtil.styleBoutonSoumettre, 2, 0, 1, 2);
	        // Ligne 3
	        g.ajoute(barreStatut, EcranUtil.styleBarreStatut, 3, 0, 1, 2);
	        
    	}
    }
}
